% improvement using K/L
dec = 1; mini = min(gnu_1, gnu_2);
k = zeros(1,mini+1);
count = 0;
%a = zeros(1,mini); b = zeros(1,mini);
while (dec)
    cutsize_old = cutsize;
    %difflist = zeros(1,N);
    for i = 1:N
        difflist(i) = diffval(i,nu_1,nu_2,pp);
    end
    marker = zeros(1,N);
    k(1) = cutsize;
    for i = 1:mini
        gainlist = zeros(gnu_1,gnu_2);
        for l = 1:gnu_1
            for m = 1:gnu_2
                if ((marker(nu_1(l)) == 0)&(marker(nu_2(m)) == 0))
                    gainlist(l,m) = gain(nu_1(l),nu_2(m),difflist,pp);
                else
                    gainlist(l,m) = -inf;
                end
            end
        end
        maxgain = max(gainlist(:));
        ind = find(maxgain == gainlist); ind = ind(1);
        inda(i) =mod(ind,gnu_1); indb(i) = ceil(ind./gnu_1);
        if inda(i) == 0
            inda(i) = gnu_1;
        end
        a(i) = nu_1(inda(i)); b(i) = nu_2(indb(i));
        marker(a(i)) = 1; marker(b(i)) = 1;        
        pp_a = pp{a(i)}; ind = find(a(i) == pp_a); pp_a(ind) = [];
        pp_b = pp{b(i)}; ind = find(b(i) == pp_b); pp_b(ind) = [];
        for v = [pp_a,pp_b]
            if (~isempty(find(v == nu_1)))
                difflist(v) = difflist(v) + 2*((~isempty(find(v == pp_a))) - (~isempty(find(v == pp_b))));
            else
                difflist(v) = difflist(v) + 2*((~isempty(find(v == pp_b))) - (~isempty(find(v == pp_a))));
            end
        end
        k(i+1) = k(i) - maxgain;
    end
    cutsize = min(k);
    ind = find(k == cutsize); ind = ind(1)-1;    
            
    % K/L in action
    for k = 1:ind
        plot(p(1,a(k)),p(2,a(k)),'o','Markeredgecolor','m','Markerfacecolor','m');
        plot(p(1,b(k)),p(2,b(k)),'o','Markeredgecolor','m','Markerfacecolor','m');
        
        pause(0.5);
        
        % update partitions
        nu_1(inda(k)) = b(k);
        nu_2(indb(k)) = a(k);
        
        hold off;
        
        for i = nu_1
            ppo = pp{i};
            for j = nu_1
                ind = find(j == ppo);
                if ~isempty(ind)
                    %plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-w','Linewidth',2);
                    plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-k');
                    hold on;
                end
            end
            for j = nu_2
                ind = find(j == ppo);
                if ~isempty(ind)
                    %plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-w','Linewidth',2);
                    plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-r','Linewidth',2);
                end
            end
        end

        for i = nu_2
            ppo = pp{i};
            for j = nu_2
                ind = find(j == ppo);
                if ~isempty(ind)
                    %plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-w','Linewidth',2);
                    plot([p(1,i) p(1,j)],[p(2,i) p(2,j)],'-k');
                end
            end
        end

        plot(p(1,nu_2),p(2,nu_2),'o','Markeredgecolor','b','Markerfacecolor','b');
        plot(p(1,nu_1),p(2,nu_1),'o','Markeredgecolor',[0 .5 0],'Markerfacecolor',[0 .5 0]);
        
        pause(0.5);
    end
    
    nu_1 = sort(nu_1);
    nu_2 = sort(nu_2);
    
    % cutsize after iteration of K/L
    count = count + 1;
    disp(['Nach ',int2str(count),'-ter Anwendung von K/L']);
    disp('Schnittkosten: ')
    disp(cutsize)
    
    % stop conditions
    if cutsize >= cutsize_old
        dec = 0;
    end
    %dec = 0;
end